package me.asofold.bpl.fighthelper;

import org.bukkit.Location;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.plugin.java.JavaPlugin;

/**
 * Reset player health unless they would die directly.
 * @author asofold
 *
 */
public class FightHelper extends JavaPlugin implements Listener {

    final Location useLoc = new Location(null, 0, 0, 0);

    @Override
    public void onDisable() {
        getLogger().info(getDescription().getFullName() + " is disabled.");
    }

    @Override
    public void onEnable() {
        getServer().getPluginManager().registerEvents(this, this);
        getServer().getScheduler().scheduleSyncRepeatingTask(this, new Runnable() {

            @Override
            public void run() {
                for (Player player : getServer().getOnlinePlayers()) {
                    if (!player.isDead() && player.getHealth() < player.getMaxHealth() && player.getHealth() > 0.0) {
                        player.setHealth(player.getMaxHealth());
                    }
                }
            }
        }, 1, 1);
        getLogger().info(getDescription().getFullName() + " is enabled.");
    }

    @EventHandler(priority = EventPriority.HIGHEST, ignoreCancelled = true)
    public void onDamage(EntityDamageEvent event) {
        switch (event.getCause()) {
            case VOID:
            case SUICIDE:
                return;
            default:
                break;
        }
        if (event.getEntity() instanceof Player) {
            int damage = 1;
            // TODO: Use the amount that would get applied (ndt).
            if (event.getFinalDamage() >= ((Player) event.getEntity()).getHealth()) {
                damage = 0;
            }
            event.setDamage(Math.min(event.getFinalDamage(), damage));
        }
    }

}
