package me.asofold.bpl.morecommands.command.action;

import me.asofold.bpl.morecommands.MoreCommands;
import me.asofold.bpl.morecommands.command.AbstractCommand;

import org.bukkit.Material;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.PlayerInventory;

public class FoodCommand extends AbstractCommand<MoreCommands>{

    public FoodCommand(MoreCommands access) {
        super(access, "food", "morecommands.command.food");
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String alias, String[] args) {
        if (!demandPlayer(sender)) {
            return true;
        }
        PlayerInventory inv = ((Player) sender).getInventory();
        ItemStack[] items = inv.getContents();
        boolean found = false;
        for (int i = 0; i < items.length; i ++) {
            ItemStack stack = items[i];
            if (stack != null && stack.getType().isEdible() && stack.getAmount() < stack.getMaxStackSize()) {
                stack.setAmount(stack.getMaxStackSize());
                found = true;
            }
        }
        if (found) {
            // inv.setContents(items); TODO: Test if to set contents.
            sender.sendMessage("Stacked up all edible items.");
        } else {
            if (!inv.addItem(new ItemStack(Material.BREAD, 64)).isEmpty()) {
                sender.sendMessage("Could not add food items.");
            } else {
                sender.sendMessage("It's bread this time!");
            }
        }
        return true;
    }

}
