package me.asofold.bpl.morecommands.command.action;

import me.asofold.bpl.morecommands.MoreCommands;
import me.asofold.bpl.morecommands.command.AbstractCommand;

import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;

public class HealCommand extends AbstractCommand<MoreCommands> {

    public HealCommand(MoreCommands access) {
        super(access, "heal", "morecommands.command.heal");
        this.usage = "Heal yourself :).";
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String alias, String[] args) {
        if (!demandPlayer(sender)) {
            return false;
        }
        if (args.length != 1) {
            return false;
        }
        Player player = (Player) sender;
        player.setHealth(player.getMaxHealth());
        player.setFoodLevel(20);
        player.setExhaustion(0);
        for (final PotionEffect effect : player.getActivePotionEffects()) {
            PotionEffectType type = effect.getType();
            if(type == PotionEffectType.POISON || type == PotionEffectType.WITHER) {
                player.removePotionEffect(type);
            }
        }
        return true;
    }

}
