package me.asofold.bpl.morecommands.command.capability;

import java.util.ArrayList;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;

import me.asofold.bpl.morecommands.MoreCommands;
import me.asofold.bpl.morecommands.command.AbstractCommand;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.permissions.PermissionAttachmentInfo;

public class PermissionsCommand extends AbstractCommand<MoreCommands>{

    public PermissionsCommand(MoreCommands access) {
        super(access, "permissions", "morecommands.command.permissions", new String[]{"perm", "perms"});
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String alias, String[] args) {
        final List<String> prefixes = args.length > 1 ? new ArrayList<String>() : null;
        final Set<String> hasNot = new LinkedHashSet<String>();
        final Set<String> has = new LinkedHashSet<String>();
        for (int i = 1; i < args.length; i++) {
            String lcPrefix = args[i];
            prefixes.add(lcPrefix);
            try {
                if (sender.hasPermission(args[i])) {
                    has.add(args[i]);
                }
                else if (sender.hasPermission(lcPrefix)) {
                    has.add(lcPrefix); // Explicit check if given - possible !?
                }
                else {
                    hasNot.add(args[i]);
                }
            } catch (Throwable t) {
                
            }
        }
        // Iterate all permission attachments.
        for (PermissionAttachmentInfo info : sender.getEffectivePermissions()) {
            if (prefixes == null) {
                (info.getValue() ? has : hasNot).add(info.getPermission());
            } else {
                String permission = info.getPermission();
                String lcPermission = permission.toLowerCase();
                for (String prefix : prefixes) {
                    if (lcPermission.startsWith(prefix)) {
                        (info.getValue() ? has : hasNot).add(permission);
                        break;
                    }
                }
            }
        }
        StringBuilder builder = new StringBuilder(4000);
        if (!has.isEmpty()) {
            builder.append(ChatColor.GREEN + "HAS");
            for (String perm : has) {
                builder.append(ChatColor.DARK_GRAY + " | " + ChatColor.GREEN);
                builder.append(perm);
            }
            builder.append(ChatColor.DARK_GRAY + " | ");
        }
        if (!hasNot.isEmpty()) {
            builder.append(ChatColor.RED + "\nhas NOT");
            for (String perm : hasNot) {
                builder.append(ChatColor.DARK_GRAY + " | " + ChatColor.RED);
                builder.append(perm);
            }
            builder.append(ChatColor.DARK_GRAY + " | ");
        }
        builder.append(ChatColor.GRAY + "\n(Specify permissions or prefixes of permissions to confine.)");
        String msg = builder.toString();
        sender.sendMessage(((sender instanceof Player) ? msg : ChatColor.stripColor(msg)));
        return true;
    }

}
