package me.asofold.bpl.morecommands.command.editworld;

import java.util.Random;

import me.asofold.bpl.morecommands.MoreCommands;
import me.asofold.bpl.morecommands.command.AbstractCommand;

import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class SnowLayerCommand extends AbstractCommand<MoreCommands>{

    private final Random random = new Random(System.nanoTime() ^ ((long) this.toString().hashCode()));

    public SnowLayerCommand(MoreCommands access) {
        super(access, "snowlayer", "morecommands.command.snowlayer");
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String alias, String[] args) {
        if (!demandPlayer(sender)) {
            return true;
        }
        if (args.length != 2) {
            sender.sendMessage("Must specify a radius.");
            return true;
        }
        try {
            placeSnowLayer((Player) sender, Integer.parseInt(args[1]));
            return true;
        } catch (NumberFormatException e) {
            sender.sendMessage("Must specify a valid radius.");
            return true;
        }
    }

    @SuppressWarnings("deprecation")
    private void placeSnowLayer(final Player player, int radius) {
        radius = Math.abs(radius);
        if (radius > 100) {
            radius = 100;
            player.sendMessage("Capping radius at 100.");
        }
        final Block centerBlock = player.getLocation().getBlock();
        final World world = centerBlock.getWorld();
        for (int x = centerBlock.getX() - radius; x <= centerBlock.getX() + radius; x ++) {
            for (int z = centerBlock.getZ() - radius; z <= centerBlock.getZ() + radius; z ++) {
                final int y = world.getHighestBlockYAt(x, z);
                final Block block = world.getBlockAt(x, y, z);
                if (block == null) {
                    continue;
                }
                final Material mat = block.getType();
                if (mat != null && (mat == Material.AIR || !mat.isSolid())) {
                    // Replace by snow with random height.
                    block.setType(Material.SNOW);
                    block.setData((byte) random.nextInt(9));
//                    BlockState state = world.getBlockAt(x, y, z).getState();
//                    MaterialData data = state.getData();
//                    data.setData((byte) random.nextInt(9));
                }
            }
        }
    }

}
