package me.asofold.bpl.morecommands.command.moving;

import me.asofold.bpl.morecommands.MoreCommands;
import me.asofold.bpl.morecommands.command.AbstractCommand;

import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class FlySpeedCommand  extends AbstractCommand<MoreCommands> {

    public FlySpeedCommand(MoreCommands access) {
        super(access, "flyspeed", "morecommands.command.flyspeed");
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String alias, String[] args) {
        if (!demandPlayer(sender)) {
            return true;
        }
        if (args.length > 2) {
            sender.sendMessage("Specify fly speed or no arguments to show current.");
            return true;
        }

        Player player = (Player) sender;
        sender.sendMessage((args.length == 1 ? "Current" : "Previous") + " fly speed: " + player.getFlySpeed());

        if (args.length <= 1) {
            return true;
        }

        Float flySpeed = null;
        try {
            flySpeed = Float.parseFloat(args[1]);
            if (Float.isNaN(flySpeed.floatValue()) || flySpeed < 0f || flySpeed > 100) {
                flySpeed = null;
            }
        } catch (NumberFormatException e) {}

        if (flySpeed == null) {
            sender.sendMessage("Unsupported fly speed: " + args[1]);
            return true;
        }

        player.setFlySpeed(flySpeed.floatValue());
        sender.sendMessage("Set fly speed to: " + player.getFlySpeed());

        return true;
    }

}
