package me.asofold.bpl.morecommands.command.moving;

import me.asofold.bpl.morecommands.MoreCommands;
import me.asofold.bpl.morecommands.command.AbstractCommand;

import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class VelocityCommand extends AbstractCommand<MoreCommands> {

    public VelocityCommand(MoreCommands access) {
        super(access, "velocity", "morecommands.command.velocity", new String[] {"vel"});
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String alias, String[] args) {
        if (!demandPlayer(sender)) {
            return true;
        }
        if (args.length != 2) {
            sender.sendMessage("Error: Specify a speed.");
            return true;
        }
        Double speed = null;
        try {
            speed = Double.parseDouble(args[1]);
            if (speed.isNaN() || speed.isInfinite()) {
                speed = null;
            }
        } catch (NumberFormatException e) {}
        if (speed == null) {
            sender.sendMessage("Bad number: " + args[1]);
            return true;
        }
        if (Math.abs(speed) > 50.0) {
            sender.sendMessage("Too large speed, cap at 20.");
            speed = 50.0;
        }
        Player player = (Player) sender;
        player.setVelocity(player.getLocation().getDirection().normalize().multiply(speed));
        return true;
    }

}
