package me.asofold.bpl.morecommands.command.moving;

import me.asofold.bpl.morecommands.MoreCommands;
import me.asofold.bpl.morecommands.command.AbstractCommand;

import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class WalkSpeedCommand extends AbstractCommand<MoreCommands> {

    public WalkSpeedCommand(MoreCommands access) {
        super(access, "walkspeed", "morecommands.command.walkspeed");
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String alias, String[] args) {
        if (!demandPlayer(sender)) {
            return true;
        }
        if (args.length > 2) {
            sender.sendMessage("Specify walk speed or no arguments to show current.");
            return true;
        }

        Player player = (Player) sender;
        sender.sendMessage((args.length == 1 ? "Current" : "Previous") + " walk speed: " + player.getWalkSpeed());

        if (args.length <= 1) {
            return true;
        }

        Float walkSpeed = null;
        try {
            walkSpeed = Float.parseFloat(args[1]);
            if (Float.isNaN(walkSpeed.floatValue()) || walkSpeed < 0f || walkSpeed > 100) {
                walkSpeed = null;
            }
        } catch (NumberFormatException e) {}

        if (walkSpeed == null) {
            sender.sendMessage("Unsupported walk speed: " + args[1]);
            return true;
        }

        player.setWalkSpeed(walkSpeed.floatValue());
        sender.sendMessage("Set walk speed to: " + player.getWalkSpeed());

        return true;
    }

}
