package me.asofold.bpl.sce.command;

import java.util.LinkedList;
import java.util.List;
import java.util.Set;

import me.asofold.bpl.sce.Session;
import me.asofold.bpl.sce.SimpleConfigEditor;
import me.asofold.bpl.sce.Util;

import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.ConfigurationSection;

public class GetCommand  extends AbstractCommand<SimpleConfigEditor>{

    public GetCommand(SimpleConfigEditor access) {
        super(access, "get", null);
    }

    @Override
    public List<String> onTabComplete(CommandSender sender, Command command, String alias, String[] args) {
        Session session = access.getSession(access.getId(sender));
        if (session == null) {
            sender.sendMessage("No session open.");
            return new LinkedList<String>();
        }
        String input = args.length <= 1 ? "" : Util.join(args, 1, " ");
        return Util.tabCompleteConfigPath(session.config, input);
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String alias, String[] args) {
        // TODO: Special case path parsing?
        String path = Util.join(args, 1, " ");
        Session session = access.getSession(access.getId(sender));
        if (session == null) {
            sender.sendMessage("No session open.");
            return true;
        }
        Object obj = session.config.get(path);
        if (obj == null) {
            // TODO: Check vs. keys of getKeys(true) ?
            sender.sendMessage("No content (null).");
            return true;
        }
        // TODO: List/keys - consider some browsing mechanism (tree view, on click etc.).
        // TODO: Other complex types (!?), maps?
        if (obj instanceof ConfigurationSection) {
            // Display keys.
            ConfigurationSection section = (ConfigurationSection) obj;
            Set<String> keys = section.getKeys(false);
            sender.sendMessage("Keys:");
            sender.sendMessage(Util.join(keys, "  "));
            sender.sendMessage("(Section with " + keys.size() + " keys.)");
        }
        else if (obj instanceof List) {
            List<?> list = (List<?>) obj;
            sender.sendMessage("List:");
            sender.sendMessage(Util.join(list, "  "));
            sender.sendMessage("(List with " + list.size() + " entries.)");
        } 
        else {
            sender.sendMessage("Value: ");
            sender.sendMessage(obj.toString());
            sender.sendMessage("(" + obj.getClass().getName() + ")");
        }
        return true;
    }

}
