package me.asofold.bpl.sce.command;

import java.io.File;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;
import java.util.UUID;

import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.YamlConfiguration;

import me.asofold.bpl.sce.Session;
import me.asofold.bpl.sce.SimpleConfigEditor;
import me.asofold.bpl.sce.Util;

public class SaveCommand  extends AbstractCommand<SimpleConfigEditor>{

    public SaveCommand(SimpleConfigEditor access) {
        super(access, "save", null);
    }

    @Override
    public List<String> onTabComplete(CommandSender sender, Command command, String alias, String[] args) {
        Session session = access.getOrOpenSession(access.getId(sender));
        if (session == null) {
            sender.sendMessage("No session open.");
            return new LinkedList<String>();
        }
        if (args.length <= 1) {
            return new LinkedList<String>();
        } else {
            File base = new File(Bukkit.getServer().getWorldContainer(), "plugins");
            return Util.tabCompleteSubPath(base, Util.join(args, 1, " "));
        }
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String alias, String[] args) {
        // TODO: Consider saving asynchronously.
        // TODO: Restrict to sub path?
        UUID id = access.getId(sender);
        Session session = access.getSession(id);
        if (session == null) {
            sender.sendMessage("No session open.");
            return true;
        }
        String path = (args.length > 1) ? Util.join(args, 1, " ") : session.configPath;
        File base = new File(Bukkit.getServer().getWorldContainer(), "plugins");
        File file = new File(base, path);
        YamlConfiguration config = new YamlConfiguration();
        Util.copyConfig(session.config, config);
        try {
            config.save(file);
        } catch (IOException e) {
            e.printStackTrace();
            sender.sendMessage("Could not save YAML to file.");
            return true;
        }
        sender.sendMessage("Saved YAML to file: " + path);
        return true;
    }

}
